package aspects;

import java.security.AccessControlException;

public abstract aspect SecurityAspect percflow(untrustedCode() || newUntrustedContext()) {

	abstract pointcut untrustedCode();
	abstract pointcut criticalCode();
	abstract pointcut newThread();
	
	pointcut newUntrustedContext() : newThread() && if(TrustedStack.cflow_untrusted.get());
		
	boolean around() : criticalCode() {
		throw new AccessControlException("Exception thrown by aspect (correct)");
	}
}
